




-- -----------------------------------------------------------
-- Entity Designer DDL Script for MySQL Server 4.1 and higher
-- -----------------------------------------------------------
-- Date Created: 02/09/2015 11:06:05
-- Generated from EDMX file: C:\Users\Gregor\Source\Repos\Projektgruppe\Framework\DeutscheBahn\Model1.edmx
-- Target version: 3.0.0.0
-- --------------------------------------------------


-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- NOTE: if the constraint does not exist, an ignorable error will be reported.
-- --------------------------------------------------

--    ALTER TABLE `DataSet1` DROP CONSTRAINT `FK_datasetdata`;
--    ALTER TABLE `DecompressedDataSet` DROP CONSTRAINT `FK_decompressed_setdecompressed_data`;
--    ALTER TABLE `ChangePointSet` DROP CONSTRAINT `FK_changepoint_setchange_point`;
--    ALTER TABLE `JobResultSet` DROP CONSTRAINT `FK_JobJobResult`;
--    ALTER TABLE `JobSet` DROP CONSTRAINT `FK_datasetJob`;
--    ALTER TABLE `ChangePointSetSet1` DROP CONSTRAINT `FK_Jobchangepoint_set`;
--    ALTER TABLE `JobResultSet` DROP CONSTRAINT `FK_changepoint_setJobResult`;
--    ALTER TABLE `JobResultSet` DROP CONSTRAINT `FK_JobResultdecompressed_set`;
--    ALTER TABLE `OptimizationResultSet` DROP CONSTRAINT `FK_JobResultOptimizationResult`;

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------
SET foreign_key_checks = 0;
    DROP TABLE IF EXISTS `DataSet1`;
    DROP TABLE IF EXISTS `DataSetSet1`;
    DROP TABLE IF EXISTS `DecompressedDataSet`;
    DROP TABLE IF EXISTS `DecompressedSetSet`;
    DROP TABLE IF EXISTS `ChangePointSetSet1`;
    DROP TABLE IF EXISTS `ChangePointSet`;
    DROP TABLE IF EXISTS `JobSet`;
    DROP TABLE IF EXISTS `JobResultSet`;
    DROP TABLE IF EXISTS `OptimizationResultSet`;
SET foreign_key_checks = 1;

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

CREATE TABLE `DataSet1`(
	`Id` int NOT NULL AUTO_INCREMENT UNIQUE, 
	`time` bigint NOT NULL, 
	`value` float NOT NULL, 
	`isChange` bool NOT NULL, 
	`dataset_Id` int NOT NULL);

ALTER TABLE `DataSet1` ADD PRIMARY KEY (Id);




CREATE TABLE `DataSetSet1`(
	`Id` int NOT NULL AUTO_INCREMENT UNIQUE, 
	`name` longtext NOT NULL);

ALTER TABLE `DataSetSet1` ADD PRIMARY KEY (Id);




CREATE TABLE `DecompressedDataSet`(
	`Id` int NOT NULL AUTO_INCREMENT UNIQUE, 
	`time` bigint NOT NULL, 
	`value` float NOT NULL, 
	`decompressed_set_Id` int NOT NULL);

ALTER TABLE `DecompressedDataSet` ADD PRIMARY KEY (Id);




CREATE TABLE `DecompressedSetSet`(
	`Id` int NOT NULL AUTO_INCREMENT UNIQUE, 
	`name` longtext NOT NULL);

ALTER TABLE `DecompressedSetSet` ADD PRIMARY KEY (Id);




CREATE TABLE `ChangePointSetSet1`(
	`Id` int NOT NULL AUTO_INCREMENT UNIQUE, 
	`Job_Id` int);

ALTER TABLE `ChangePointSetSet1` ADD PRIMARY KEY (Id);




CREATE TABLE `ChangePointSet`(
	`Id` int NOT NULL AUTO_INCREMENT UNIQUE, 
	`time` bigint NOT NULL, 
	`value` float NOT NULL, 
	`changepoint_set_Id` int NOT NULL);

ALTER TABLE `ChangePointSet` ADD PRIMARY KEY (Id);




CREATE TABLE `JobSet`(
	`Id` int NOT NULL AUTO_INCREMENT UNIQUE, 
	`status` longtext NOT NULL, 
	`json` longtext NOT NULL, 
	`exception` longtext, 
	`stacktrace` longtext, 
	`name` longtext, 
	`starttime` datetime, 
	`endtime` datetime, 
	`resolver` longtext, 
	`dataset_Id` int NOT NULL);

ALTER TABLE `JobSet` ADD PRIMARY KEY (Id);




CREATE TABLE `JobResultSet`(
	`Id` int NOT NULL AUTO_INCREMENT UNIQUE, 
	`Fitness` float NOT NULL, 
	`PC` float NOT NULL, 
	`MISS` float NOT NULL, 
	`FP` float NOT NULL, 
	`errPC` float NOT NULL, 
	`errMISS` float NOT NULL, 
	`errFP` float NOT NULL, 
	`CompressionRatio` float NOT NULL, 
	`CompressionParameters` longtext NOT NULL, 
	`ChangeDetectionParameters` longtext NOT NULL, 
	`RMSE` float NOT NULL, 
	`isGoodFinalResult` bool, 
	`Job_Id` int NOT NULL, 
	`changepoint_set_Id` int NOT NULL, 
	`decompressed_set_Id` int NOT NULL);

ALTER TABLE `JobResultSet` ADD PRIMARY KEY (Id);




CREATE TABLE `OptimizationResultSet`(
	`Id` int NOT NULL AUTO_INCREMENT UNIQUE, 
	`rang` int NOT NULL, 
	`compressionratio` double NOT NULL, 
	`errortotal` double NOT NULL, 
	`params` longtext NOT NULL, 
	`JobResult_Id` int NOT NULL);

ALTER TABLE `OptimizationResultSet` ADD PRIMARY KEY (Id);






-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on `dataset_Id` in table 'DataSet1'

ALTER TABLE `DataSet1`
ADD CONSTRAINT `FK_datasetdata`
    FOREIGN KEY (`dataset_Id`)
    REFERENCES `DataSetSet1`
        (`Id`)
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_datasetdata'

CREATE INDEX `IX_FK_datasetdata` 
    ON `DataSet1`
    (`dataset_Id`);

-- Creating foreign key on `decompressed_set_Id` in table 'DecompressedDataSet'

ALTER TABLE `DecompressedDataSet`
ADD CONSTRAINT `FK_decompressed_setdecompressed_data`
    FOREIGN KEY (`decompressed_set_Id`)
    REFERENCES `DecompressedSetSet`
        (`Id`)
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_decompressed_setdecompressed_data'

CREATE INDEX `IX_FK_decompressed_setdecompressed_data` 
    ON `DecompressedDataSet`
    (`decompressed_set_Id`);

-- Creating foreign key on `changepoint_set_Id` in table 'ChangePointSet'

ALTER TABLE `ChangePointSet`
ADD CONSTRAINT `FK_changepoint_setchange_point`
    FOREIGN KEY (`changepoint_set_Id`)
    REFERENCES `ChangePointSetSet1`
        (`Id`)
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_changepoint_setchange_point'

CREATE INDEX `IX_FK_changepoint_setchange_point` 
    ON `ChangePointSet`
    (`changepoint_set_Id`);

-- Creating foreign key on `Job_Id` in table 'JobResultSet'

ALTER TABLE `JobResultSet`
ADD CONSTRAINT `FK_JobJobResult`
    FOREIGN KEY (`Job_Id`)
    REFERENCES `JobSet`
        (`Id`)
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_JobJobResult'

CREATE INDEX `IX_FK_JobJobResult` 
    ON `JobResultSet`
    (`Job_Id`);

-- Creating foreign key on `dataset_Id` in table 'JobSet'

ALTER TABLE `JobSet`
ADD CONSTRAINT `FK_datasetJob`
    FOREIGN KEY (`dataset_Id`)
    REFERENCES `DataSetSet1`
        (`Id`)
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_datasetJob'

CREATE INDEX `IX_FK_datasetJob` 
    ON `JobSet`
    (`dataset_Id`);

-- Creating foreign key on `Job_Id` in table 'ChangePointSetSet1'

ALTER TABLE `ChangePointSetSet1`
ADD CONSTRAINT `FK_Jobchangepoint_set`
    FOREIGN KEY (`Job_Id`)
    REFERENCES `JobSet`
        (`Id`)
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_Jobchangepoint_set'

CREATE INDEX `IX_FK_Jobchangepoint_set` 
    ON `ChangePointSetSet1`
    (`Job_Id`);

-- Creating foreign key on `changepoint_set_Id` in table 'JobResultSet'

ALTER TABLE `JobResultSet`
ADD CONSTRAINT `FK_changepoint_setJobResult`
    FOREIGN KEY (`changepoint_set_Id`)
    REFERENCES `ChangePointSetSet1`
        (`Id`)
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_changepoint_setJobResult'

CREATE INDEX `IX_FK_changepoint_setJobResult` 
    ON `JobResultSet`
    (`changepoint_set_Id`);

-- Creating foreign key on `decompressed_set_Id` in table 'JobResultSet'

ALTER TABLE `JobResultSet`
ADD CONSTRAINT `FK_JobResultdecompressed_set`
    FOREIGN KEY (`decompressed_set_Id`)
    REFERENCES `DecompressedSetSet`
        (`Id`)
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_JobResultdecompressed_set'

CREATE INDEX `IX_FK_JobResultdecompressed_set` 
    ON `JobResultSet`
    (`decompressed_set_Id`);

-- Creating foreign key on `JobResult_Id` in table 'OptimizationResultSet'

ALTER TABLE `OptimizationResultSet`
ADD CONSTRAINT `FK_JobResultOptimizationResult`
    FOREIGN KEY (`JobResult_Id`)
    REFERENCES `JobResultSet`
        (`Id`)
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_JobResultOptimizationResult'

CREATE INDEX `IX_FK_JobResultOptimizationResult` 
    ON `OptimizationResultSet`
    (`JobResult_Id`);

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------
