﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Framework.changedetection;
using CompressionFrameworkLib;
using System.Drawing;
using Framework.compression;
using Framework.optimization;
using System.IO;
using System.Threading;

namespace Framework
{
    class Program
    {
        public static float[] rawData;
        public static String lastFitnessParams = "";
        public static DeutscheBahn.DataSet taggedData;
        public static float[] decompData;
        public static ICompressionAlgorithm CompAlgo;
        public static IChangeDetectionAlgorithm CpAlgo;
        public static IOptimizationAlgorithm OptAlgo;
        public static float[] rawChangePointScores;
        public static float[] decompChangePointScores;
        public static int[] rawChangePoints;
        public static int[] decompChangePoints;

        [STAThread] // der FileDialog im Load Dataset Button löst eine ThreadStateException aus bei Multithreading
        static void Main(string[] args)
        {
            //Set Localizaton to  US ...
            Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("en-Us");
            string datePatt = @"yyyy-MM-ddTHH.mm.ss";

            FileStream fs = new FileStream("console_"+DateTime.Now.ToString(datePatt)+".txt", FileMode.Create);
            // First, save the standard output.
            TextWriter tmp = Console.Out;
            StreamWriter sw = new StreamWriter(fs);
            sw.AutoFlush = true;
            Console.SetOut(sw);

            // GUI //
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            GUI_main mainForm = new GUI_main();
#if DEBUG
            Application.Run(mainForm);
#else
            try
            {
                Application.Run(mainForm);
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                Console.WriteLine(e.StackTrace);
                sw.Flush();
                MessageBox.Show(e.Message, "Exception",  MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
#endif
            

            Application.Exit();

            sw.Flush();
            Console.SetOut(tmp);
            sw.Close();
            fs.Close();
        }
    }
}
